package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.commons.utils.PageUtil;
import com.loafle.overflow.central.module.infra.dao.InfraDAO;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.central.module.sensor.dao.SensorDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.service.central.infra.InfraService;
import com.loafle.overflow.service.central.probe.ProbeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

import java.util.List;


@Service("InfraService")
public class CentralInfraService implements InfraService {

  @Autowired
  InfraDAO infraDAO;

  @Autowired
  SensorDAO sensorDAO;

  @Autowired
  private ProbeService probeService;

  public Infra regist(Infra infra) throws OverflowException {
    return this.infraDAO.save(infra);
  }

  public Infra read(Long id) throws OverflowException {
    return this.infraDAO.findById(id).get();
  }

  public Page<Infra> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException {
    return this.infraDAO.findAllByProbeId(probeID, PageUtil.getPageRequest(pageParams));
  }

  public Page<Infra> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException {
    List<Probe> probeList = this.probeService.readAllByDomainID(domainID);

    if (probeList == null || probeList.size() <= 0) {
      throw new OverflowException("ProbeNotFoundException", new Throwable());
    }

    Page<Infra> infraList = this.infraDAO.findAllByProbeIn(probeList, PageUtil.getPageRequest(pageParams));
    return infraList;
  }

}
